/* UnicodeScripts.h */
/* THIS IS A GENERATED FILE. CHANGES WILL BE OVERWRITTEN. */
/* Generated by generate-unicode-tables.pl */
/* Generated from UCD version 5.0 */

#ifndef __UNICODE_SCRIPTS_H__
#define __UNICODE_SCRIPTS_H__

#include <QtCore/QtGlobal>
#include <KDE/KLocalizedString>

static const char *constUnicodeScriptList[] =
{
    I18N_NOOP("Arabic"),
    I18N_NOOP("Armenian"),
    I18N_NOOP("Balinese"),
    I18N_NOOP("Bengali"),
    I18N_NOOP("Bopomofo"),
    I18N_NOOP("Braille"),
    I18N_NOOP("Buginese"),
    I18N_NOOP("Buhid"),
    I18N_NOOP("Canadian Aboriginal"),
    I18N_NOOP("Cherokee"),
    I18N_NOOP("Common"),
    I18N_NOOP("Coptic"),
    I18N_NOOP("Cuneiform"),
    I18N_NOOP("Cypriot"),
    I18N_NOOP("Cyrillic"),
    I18N_NOOP("Deseret"),
    I18N_NOOP("Devanagari"),
    I18N_NOOP("Ethiopic"),
    I18N_NOOP("Georgian"),
    I18N_NOOP("Glagolitic"),
    I18N_NOOP("Gothic"),
    I18N_NOOP("Greek"),
    I18N_NOOP("Gujarati"),
    I18N_NOOP("Gurmukhi"),
    I18N_NOOP("Han"),
    I18N_NOOP("Hangul"),
    I18N_NOOP("Hanunoo"),
    I18N_NOOP("Hebrew"),
    I18N_NOOP("Hiragana"),
    I18N_NOOP("Inherited"),
    I18N_NOOP("Kannada"),
    I18N_NOOP("Katakana"),
    I18N_NOOP("Kharoshthi"),
    I18N_NOOP("Khmer"),
    I18N_NOOP("Lao"),
    I18N_NOOP("Latin"),
    I18N_NOOP("Limbu"),
    I18N_NOOP("Linear B"),
    I18N_NOOP("Malayalam"),
    I18N_NOOP("Mongolian"),
    I18N_NOOP("Myanmar"),
    I18N_NOOP("New Tai Lue"),
    I18N_NOOP("Nko"),
    I18N_NOOP("Ogham"),
    I18N_NOOP("Old Italic"),
    I18N_NOOP("Old Persian"),
    I18N_NOOP("Oriya"),
    I18N_NOOP("Osmanya"),
    I18N_NOOP("Phags Pa"),
    I18N_NOOP("Phoenician"),
    I18N_NOOP("Runic"),
    I18N_NOOP("Shavian"),
    I18N_NOOP("Sinhala"),
    I18N_NOOP("Syloti Nagri"),
    I18N_NOOP("Syriac"),
    I18N_NOOP("Tagalog"),
    I18N_NOOP("Tagbanwa"),
    I18N_NOOP("Tai Le"),
    I18N_NOOP("Tamil"),
    I18N_NOOP("Telugu"),
    I18N_NOOP("Thaana"),
    I18N_NOOP("Thai"),
    I18N_NOOP("Tibetan"),
    I18N_NOOP("Tifinagh"),
    I18N_NOOP("Ugaritic"),
    I18N_NOOP("Yi"),
    NULL
};

struct TUnicodeScript
{
    quint32 start,
            end;
    int     scriptIndex;   /* index into constUnicodeScriptList */
};

static const TUnicodeScript constUnicodeScripts[] =
{
    { 0x0000, 0x001F, 10 },
    { 0x0020, 0x0020, 10 },
    { 0x0021, 0x0023, 10 },
    { 0x0024, 0x0024, 10 },
    { 0x0025, 0x0027, 10 },
    { 0x0028, 0x0028, 10 },
    { 0x0029, 0x0029, 10 },
    { 0x002A, 0x002A, 10 },
    { 0x002B, 0x002B, 10 },
    { 0x002C, 0x002C, 10 },
    { 0x002D, 0x002D, 10 },
    { 0x002E, 0x002F, 10 },
    { 0x0030, 0x0039, 10 },
    { 0x003A, 0x003B, 10 },
    { 0x003C, 0x003E, 10 },
    { 0x003F, 0x0040, 10 },
    { 0x0041, 0x005A, 35 },
    { 0x005B, 0x005B, 10 },
    { 0x005C, 0x005C, 10 },
    { 0x005D, 0x005D, 10 },
    { 0x005E, 0x005E, 10 },
    { 0x005F, 0x005F, 10 },
    { 0x0060, 0x0060, 10 },
    { 0x0061, 0x007A, 35 },
    { 0x007B, 0x007B, 10 },
    { 0x007C, 0x007C, 10 },
    { 0x007D, 0x007D, 10 },
    { 0x007E, 0x007E, 10 },
    { 0x007F, 0x009F, 10 },
    { 0x00A0, 0x00A0, 10 },
    { 0x00A1, 0x00A1, 10 },
    { 0x00A2, 0x00A5, 10 },
    { 0x00A6, 0x00A7, 10 },
    { 0x00A8, 0x00A8, 10 },
    { 0x00A9, 0x00A9, 10 },
    { 0x00AA, 0x00AA, 35 },
    { 0x00AB, 0x00AB, 10 },
    { 0x00AC, 0x00AC, 10 },
    { 0x00AD, 0x00AD, 10 },
    { 0x00AE, 0x00AE, 10 },
    { 0x00AF, 0x00AF, 10 },
    { 0x00B0, 0x00B0, 10 },
    { 0x00B1, 0x00B1, 10 },
    { 0x00B2, 0x00B3, 10 },
    { 0x00B4, 0x00B4, 10 },
    { 0x00B5, 0x00B5, 10 },
    { 0x00B6, 0x00B6, 10 },
    { 0x00B7, 0x00B7, 10 },
    { 0x00B8, 0x00B8, 10 },
    { 0x00B9, 0x00B9, 10 },
    { 0x00BA, 0x00BA, 35 },
    { 0x00BB, 0x00BB, 10 },
    { 0x00BC, 0x00BE, 10 },
    { 0x00BF, 0x00BF, 10 },
    { 0x00C0, 0x00D6, 35 },
    { 0x00D7, 0x00D7, 10 },
    { 0x00D8, 0x00F6, 35 },
    { 0x00F7, 0x00F7, 10 },
    { 0x00F8, 0x01BA, 35 },
    { 0x01BB, 0x01BB, 35 },
    { 0x01BC, 0x01BF, 35 },
    { 0x01C0, 0x01C3, 35 },
    { 0x01C4, 0x0293, 35 },
    { 0x0294, 0x0294, 35 },
    { 0x0295, 0x02AF, 35 },
    { 0x02B0, 0x02B8, 35 },
    { 0x02B9, 0x02C1, 10 },
    { 0x02C2, 0x02C5, 10 },
    { 0x02C6, 0x02D1, 10 },
    { 0x02D2, 0x02DF, 10 },
    { 0x02E0, 0x02E4, 35 },
    { 0x02E5, 0x02ED, 10 },
    { 0x02EE, 0x02EE, 10 },
    { 0x02EF, 0x02FF, 10 },
    { 0x0300, 0x036F, 29 },
    { 0x0374, 0x0375, 21 },
    { 0x037A, 0x037A, 21 },
    { 0x037B, 0x037D, 21 },
    { 0x037E, 0x037E, 10 },
    { 0x0384, 0x0385, 21 },
    { 0x0386, 0x0386, 21 },
    { 0x0387, 0x0387, 10 },
    { 0x0388, 0x038A, 21 },
    { 0x038C, 0x038C, 21 },
    { 0x038E, 0x03A1, 21 },
    { 0x03A3, 0x03CE, 21 },
    { 0x03D0, 0x03E1, 21 },
    { 0x03E2, 0x03EF, 11 },
    { 0x03F0, 0x03F5, 21 },
    { 0x03F6, 0x03F6, 21 },
    { 0x03F7, 0x03FF, 21 },
    { 0x0400, 0x0481, 14 },
    { 0x0482, 0x0482, 14 },
    { 0x0483, 0x0486, 14 },
    { 0x0488, 0x0489, 14 },
    { 0x048A, 0x0513, 14 },
    { 0x0531, 0x0556,  1 },
    { 0x0559, 0x0559,  1 },
    { 0x055A, 0x055F,  1 },
    { 0x0561, 0x0587,  1 },
    { 0x0589, 0x0589, 10 },
    { 0x058A, 0x058A,  1 },
    { 0x0591, 0x05BD, 27 },
    { 0x05BE, 0x05BE, 27 },
    { 0x05BF, 0x05BF, 27 },
    { 0x05C0, 0x05C0, 27 },
    { 0x05C1, 0x05C2, 27 },
    { 0x05C3, 0x05C3, 27 },
    { 0x05C4, 0x05C5, 27 },
    { 0x05C6, 0x05C6, 27 },
    { 0x05C7, 0x05C7, 27 },
    { 0x05D0, 0x05EA, 27 },
    { 0x05F0, 0x05F2, 27 },
    { 0x05F3, 0x05F4, 27 },
    { 0x0600, 0x0603, 10 },
    { 0x060B, 0x060B,  0 },
    { 0x060C, 0x060C, 10 },
    { 0x060D, 0x060D,  0 },
    { 0x060E, 0x060F,  0 },
    { 0x0610, 0x0615,  0 },
    { 0x061B, 0x061B, 10 },
    { 0x061E, 0x061E,  0 },
    { 0x061F, 0x061F, 10 },
    { 0x0621, 0x063A,  0 },
    { 0x0640, 0x0640, 10 },
    { 0x0641, 0x064A,  0 },
    { 0x064B, 0x0655, 29 },
    { 0x0656, 0x065E,  0 },
    { 0x0660, 0x0669, 10 },
    { 0x066A, 0x066D,  0 },
    { 0x066E, 0x066F,  0 },
    { 0x0670, 0x0670, 29 },
    { 0x0671, 0x06D3,  0 },
    { 0x06D4, 0x06D4,  0 },
    { 0x06D5, 0x06D5,  0 },
    { 0x06D6, 0x06DC,  0 },
    { 0x06DD, 0x06DD, 10 },
    { 0x06DE, 0x06DE,  0 },
    { 0x06DF, 0x06E4,  0 },
    { 0x06E5, 0x06E6,  0 },
    { 0x06E7, 0x06E8,  0 },
    { 0x06E9, 0x06E9,  0 },
    { 0x06EA, 0x06ED,  0 },
    { 0x06EE, 0x06EF,  0 },
    { 0x06F0, 0x06F9,  0 },
    { 0x06FA, 0x06FC,  0 },
    { 0x06FD, 0x06FE,  0 },
    { 0x06FF, 0x06FF,  0 },
    { 0x0700, 0x070D, 54 },
    { 0x070F, 0x070F, 54 },
    { 0x0710, 0x0710, 54 },
    { 0x0711, 0x0711, 54 },
    { 0x0712, 0x072F, 54 },
    { 0x0730, 0x074A, 54 },
    { 0x074D, 0x074F, 54 },
    { 0x0750, 0x076D,  0 },
    { 0x0780, 0x07A5, 60 },
    { 0x07A6, 0x07B0, 60 },
    { 0x07B1, 0x07B1, 60 },
    { 0x07C0, 0x07C9, 42 },
    { 0x07CA, 0x07EA, 42 },
    { 0x07EB, 0x07F3, 42 },
    { 0x07F4, 0x07F5, 42 },
    { 0x07F6, 0x07F6, 42 },
    { 0x07F7, 0x07F9, 42 },
    { 0x07FA, 0x07FA, 42 },
    { 0x0901, 0x0902, 16 },
    { 0x0903, 0x0903, 16 },
    { 0x0904, 0x0939, 16 },
    { 0x093C, 0x093C, 16 },
    { 0x093D, 0x093D, 16 },
    { 0x093E, 0x0940, 16 },
    { 0x0941, 0x0948, 16 },
    { 0x0949, 0x094C, 16 },
    { 0x094D, 0x094D, 16 },
    { 0x0950, 0x0950, 16 },
    { 0x0951, 0x0954, 16 },
    { 0x0958, 0x0961, 16 },
    { 0x0962, 0x0963, 16 },
    { 0x0964, 0x0965, 10 },
    { 0x0966, 0x096F, 16 },
    { 0x0970, 0x0970, 10 },
    { 0x097B, 0x097F, 16 },
    { 0x0981, 0x0981,  3 },
    { 0x0982, 0x0983,  3 },
    { 0x0985, 0x098C,  3 },
    { 0x098F, 0x0990,  3 },
    { 0x0993, 0x09A8,  3 },
    { 0x09AA, 0x09B0,  3 },
    { 0x09B2, 0x09B2,  3 },
    { 0x09B6, 0x09B9,  3 },
    { 0x09BC, 0x09BC,  3 },
    { 0x09BD, 0x09BD,  3 },
    { 0x09BE, 0x09C0,  3 },
    { 0x09C1, 0x09C4,  3 },
    { 0x09C7, 0x09C8,  3 },
    { 0x09CB, 0x09CC,  3 },
    { 0x09CD, 0x09CD,  3 },
    { 0x09CE, 0x09CE,  3 },
    { 0x09D7, 0x09D7,  3 },
    { 0x09DC, 0x09DD,  3 },
    { 0x09DF, 0x09E1,  3 },
    { 0x09E2, 0x09E3,  3 },
    { 0x09E6, 0x09EF,  3 },
    { 0x09F0, 0x09F1,  3 },
    { 0x09F2, 0x09F3,  3 },
    { 0x09F4, 0x09F9,  3 },
    { 0x09FA, 0x09FA,  3 },
    { 0x0A01, 0x0A02, 23 },
    { 0x0A03, 0x0A03, 23 },
    { 0x0A05, 0x0A0A, 23 },
    { 0x0A0F, 0x0A10, 23 },
    { 0x0A13, 0x0A28, 23 },
    { 0x0A2A, 0x0A30, 23 },
    { 0x0A32, 0x0A33, 23 },
    { 0x0A35, 0x0A36, 23 },
    { 0x0A38, 0x0A39, 23 },
    { 0x0A3C, 0x0A3C, 23 },
    { 0x0A3E, 0x0A40, 23 },
    { 0x0A41, 0x0A42, 23 },
    { 0x0A47, 0x0A48, 23 },
    { 0x0A4B, 0x0A4D, 23 },
    { 0x0A59, 0x0A5C, 23 },
    { 0x0A5E, 0x0A5E, 23 },
    { 0x0A66, 0x0A6F, 23 },
    { 0x0A70, 0x0A71, 23 },
    { 0x0A72, 0x0A74, 23 },
    { 0x0A81, 0x0A82, 22 },
    { 0x0A83, 0x0A83, 22 },
    { 0x0A85, 0x0A8D, 22 },
    { 0x0A8F, 0x0A91, 22 },
    { 0x0A93, 0x0AA8, 22 },
    { 0x0AAA, 0x0AB0, 22 },
    { 0x0AB2, 0x0AB3, 22 },
    { 0x0AB5, 0x0AB9, 22 },
    { 0x0ABC, 0x0ABC, 22 },
    { 0x0ABD, 0x0ABD, 22 },
    { 0x0ABE, 0x0AC0, 22 },
    { 0x0AC1, 0x0AC5, 22 },
    { 0x0AC7, 0x0AC8, 22 },
    { 0x0AC9, 0x0AC9, 22 },
    { 0x0ACB, 0x0ACC, 22 },
    { 0x0ACD, 0x0ACD, 22 },
    { 0x0AD0, 0x0AD0, 22 },
    { 0x0AE0, 0x0AE1, 22 },
    { 0x0AE2, 0x0AE3, 22 },
    { 0x0AE6, 0x0AEF, 22 },
    { 0x0AF1, 0x0AF1, 22 },
    { 0x0B01, 0x0B01, 46 },
    { 0x0B02, 0x0B03, 46 },
    { 0x0B05, 0x0B0C, 46 },
    { 0x0B0F, 0x0B10, 46 },
    { 0x0B13, 0x0B28, 46 },
    { 0x0B2A, 0x0B30, 46 },
    { 0x0B32, 0x0B33, 46 },
    { 0x0B35, 0x0B39, 46 },
    { 0x0B3C, 0x0B3C, 46 },
    { 0x0B3D, 0x0B3D, 46 },
    { 0x0B3E, 0x0B3E, 46 },
    { 0x0B3F, 0x0B3F, 46 },
    { 0x0B40, 0x0B40, 46 },
    { 0x0B41, 0x0B43, 46 },
    { 0x0B47, 0x0B48, 46 },
    { 0x0B4B, 0x0B4C, 46 },
    { 0x0B4D, 0x0B4D, 46 },
    { 0x0B56, 0x0B56, 46 },
    { 0x0B57, 0x0B57, 46 },
    { 0x0B5C, 0x0B5D, 46 },
    { 0x0B5F, 0x0B61, 46 },
    { 0x0B66, 0x0B6F, 46 },
    { 0x0B70, 0x0B70, 46 },
    { 0x0B71, 0x0B71, 46 },
    { 0x0B82, 0x0B82, 58 },
    { 0x0B83, 0x0B83, 58 },
    { 0x0B85, 0x0B8A, 58 },
    { 0x0B8E, 0x0B90, 58 },
    { 0x0B92, 0x0B95, 58 },
    { 0x0B99, 0x0B9A, 58 },
    { 0x0B9C, 0x0B9C, 58 },
    { 0x0B9E, 0x0B9F, 58 },
    { 0x0BA3, 0x0BA4, 58 },
    { 0x0BA8, 0x0BAA, 58 },
    { 0x0BAE, 0x0BB9, 58 },
    { 0x0BBE, 0x0BBF, 58 },
    { 0x0BC0, 0x0BC0, 58 },
    { 0x0BC1, 0x0BC2, 58 },
    { 0x0BC6, 0x0BC8, 58 },
    { 0x0BCA, 0x0BCC, 58 },
    { 0x0BCD, 0x0BCD, 58 },
    { 0x0BD7, 0x0BD7, 58 },
    { 0x0BE6, 0x0BEF, 58 },
    { 0x0BF0, 0x0BF2, 58 },
    { 0x0BF3, 0x0BF8, 58 },
    { 0x0BF9, 0x0BF9, 58 },
    { 0x0BFA, 0x0BFA, 58 },
    { 0x0C01, 0x0C03, 59 },
    { 0x0C05, 0x0C0C, 59 },
    { 0x0C0E, 0x0C10, 59 },
    { 0x0C12, 0x0C28, 59 },
    { 0x0C2A, 0x0C33, 59 },
    { 0x0C35, 0x0C39, 59 },
    { 0x0C3E, 0x0C40, 59 },
    { 0x0C41, 0x0C44, 59 },
    { 0x0C46, 0x0C48, 59 },
    { 0x0C4A, 0x0C4D, 59 },
    { 0x0C55, 0x0C56, 59 },
    { 0x0C60, 0x0C61, 59 },
    { 0x0C66, 0x0C6F, 59 },
    { 0x0C82, 0x0C83, 30 },
    { 0x0C85, 0x0C8C, 30 },
    { 0x0C8E, 0x0C90, 30 },
    { 0x0C92, 0x0CA8, 30 },
    { 0x0CAA, 0x0CB3, 30 },
    { 0x0CB5, 0x0CB9, 30 },
    { 0x0CBC, 0x0CBC, 30 },
    { 0x0CBD, 0x0CBD, 30 },
    { 0x0CBE, 0x0CBE, 30 },
    { 0x0CBF, 0x0CBF, 30 },
    { 0x0CC0, 0x0CC4, 30 },
    { 0x0CC6, 0x0CC6, 30 },
    { 0x0CC7, 0x0CC8, 30 },
    { 0x0CCA, 0x0CCB, 30 },
    { 0x0CCC, 0x0CCD, 30 },
    { 0x0CD5, 0x0CD6, 30 },
    { 0x0CDE, 0x0CDE, 30 },
    { 0x0CE0, 0x0CE1, 30 },
    { 0x0CE2, 0x0CE3, 30 },
    { 0x0CE6, 0x0CEF, 30 },
    { 0x0CF1, 0x0CF2, 30 },
    { 0x0D02, 0x0D03, 38 },
    { 0x0D05, 0x0D0C, 38 },
    { 0x0D0E, 0x0D10, 38 },
    { 0x0D12, 0x0D28, 38 },
    { 0x0D2A, 0x0D39, 38 },
    { 0x0D3E, 0x0D40, 38 },
    { 0x0D41, 0x0D43, 38 },
    { 0x0D46, 0x0D48, 38 },
    { 0x0D4A, 0x0D4C, 38 },
    { 0x0D4D, 0x0D4D, 38 },
    { 0x0D57, 0x0D57, 38 },
    { 0x0D60, 0x0D61, 38 },
    { 0x0D66, 0x0D6F, 38 },
    { 0x0D82, 0x0D83, 52 },
    { 0x0D85, 0x0D96, 52 },
    { 0x0D9A, 0x0DB1, 52 },
    { 0x0DB3, 0x0DBB, 52 },
    { 0x0DBD, 0x0DBD, 52 },
    { 0x0DC0, 0x0DC6, 52 },
    { 0x0DCA, 0x0DCA, 52 },
    { 0x0DCF, 0x0DD1, 52 },
    { 0x0DD2, 0x0DD4, 52 },
    { 0x0DD6, 0x0DD6, 52 },
    { 0x0DD8, 0x0DDF, 52 },
    { 0x0DF2, 0x0DF3, 52 },
    { 0x0DF4, 0x0DF4, 52 },
    { 0x0E01, 0x0E30, 61 },
    { 0x0E31, 0x0E31, 61 },
    { 0x0E32, 0x0E33, 61 },
    { 0x0E34, 0x0E3A, 61 },
    { 0x0E3F, 0x0E3F, 10 },
    { 0x0E40, 0x0E45, 61 },
    { 0x0E46, 0x0E46, 61 },
    { 0x0E47, 0x0E4E, 61 },
    { 0x0E4F, 0x0E4F, 61 },
    { 0x0E50, 0x0E59, 61 },
    { 0x0E5A, 0x0E5B, 61 },
    { 0x0E81, 0x0E82, 34 },
    { 0x0E84, 0x0E84, 34 },
    { 0x0E87, 0x0E88, 34 },
    { 0x0E8A, 0x0E8A, 34 },
    { 0x0E8D, 0x0E8D, 34 },
    { 0x0E94, 0x0E97, 34 },
    { 0x0E99, 0x0E9F, 34 },
    { 0x0EA1, 0x0EA3, 34 },
    { 0x0EA5, 0x0EA5, 34 },
    { 0x0EA7, 0x0EA7, 34 },
    { 0x0EAA, 0x0EAB, 34 },
    { 0x0EAD, 0x0EB0, 34 },
    { 0x0EB1, 0x0EB1, 34 },
    { 0x0EB2, 0x0EB3, 34 },
    { 0x0EB4, 0x0EB9, 34 },
    { 0x0EBB, 0x0EBC, 34 },
    { 0x0EBD, 0x0EBD, 34 },
    { 0x0EC0, 0x0EC4, 34 },
    { 0x0EC6, 0x0EC6, 34 },
    { 0x0EC8, 0x0ECD, 34 },
    { 0x0ED0, 0x0ED9, 34 },
    { 0x0EDC, 0x0EDD, 34 },
    { 0x0F00, 0x0F00, 62 },
    { 0x0F01, 0x0F03, 62 },
    { 0x0F04, 0x0F12, 62 },
    { 0x0F13, 0x0F17, 62 },
    { 0x0F18, 0x0F19, 62 },
    { 0x0F1A, 0x0F1F, 62 },
    { 0x0F20, 0x0F29, 62 },
    { 0x0F2A, 0x0F33, 62 },
    { 0x0F34, 0x0F34, 62 },
    { 0x0F35, 0x0F35, 62 },
    { 0x0F36, 0x0F36, 62 },
    { 0x0F37, 0x0F37, 62 },
    { 0x0F38, 0x0F38, 62 },
    { 0x0F39, 0x0F39, 62 },
    { 0x0F3A, 0x0F3A, 62 },
    { 0x0F3B, 0x0F3B, 62 },
    { 0x0F3C, 0x0F3C, 62 },
    { 0x0F3D, 0x0F3D, 62 },
    { 0x0F3E, 0x0F3F, 62 },
    { 0x0F40, 0x0F47, 62 },
    { 0x0F49, 0x0F6A, 62 },
    { 0x0F71, 0x0F7E, 62 },
    { 0x0F7F, 0x0F7F, 62 },
    { 0x0F80, 0x0F84, 62 },
    { 0x0F85, 0x0F85, 62 },
    { 0x0F86, 0x0F87, 62 },
    { 0x0F88, 0x0F8B, 62 },
    { 0x0F90, 0x0F97, 62 },
    { 0x0F99, 0x0FBC, 62 },
    { 0x0FBE, 0x0FC5, 62 },
    { 0x0FC6, 0x0FC6, 62 },
    { 0x0FC7, 0x0FCC, 62 },
    { 0x0FCF, 0x0FCF, 62 },
    { 0x0FD0, 0x0FD1, 62 },
    { 0x1000, 0x1021, 40 },
    { 0x1023, 0x1027, 40 },
    { 0x1029, 0x102A, 40 },
    { 0x102C, 0x102C, 40 },
    { 0x102D, 0x1030, 40 },
    { 0x1031, 0x1031, 40 },
    { 0x1032, 0x1032, 40 },
    { 0x1036, 0x1037, 40 },
    { 0x1038, 0x1038, 40 },
    { 0x1039, 0x1039, 40 },
    { 0x1040, 0x1049, 40 },
    { 0x104A, 0x104F, 40 },
    { 0x1050, 0x1055, 40 },
    { 0x1056, 0x1057, 40 },
    { 0x1058, 0x1059, 40 },
    { 0x10A0, 0x10C5, 18 },
    { 0x10D0, 0x10FA, 18 },
    { 0x10FB, 0x10FB, 10 },
    { 0x10FC, 0x10FC, 18 },
    { 0x1100, 0x1159, 25 },
    { 0x115F, 0x11A2, 25 },
    { 0x11A8, 0x11F9, 25 },
    { 0x1200, 0x1248, 17 },
    { 0x124A, 0x124D, 17 },
    { 0x1250, 0x1256, 17 },
    { 0x1258, 0x1258, 17 },
    { 0x125A, 0x125D, 17 },
    { 0x1260, 0x1288, 17 },
    { 0x128A, 0x128D, 17 },
    { 0x1290, 0x12B0, 17 },
    { 0x12B2, 0x12B5, 17 },
    { 0x12B8, 0x12BE, 17 },
    { 0x12C0, 0x12C0, 17 },
    { 0x12C2, 0x12C5, 17 },
    { 0x12C8, 0x12D6, 17 },
    { 0x12D8, 0x1310, 17 },
    { 0x1312, 0x1315, 17 },
    { 0x1318, 0x135A, 17 },
    { 0x135F, 0x135F, 17 },
    { 0x1360, 0x1360, 17 },
    { 0x1361, 0x1368, 17 },
    { 0x1369, 0x137C, 17 },
    { 0x1380, 0x138F, 17 },
    { 0x1390, 0x1399, 17 },
    { 0x13A0, 0x13F4,  9 },
    { 0x1401, 0x166C,  8 },
    { 0x166D, 0x166E,  8 },
    { 0x166F, 0x1676,  8 },
    { 0x1680, 0x1680, 43 },
    { 0x1681, 0x169A, 43 },
    { 0x169B, 0x169B, 43 },
    { 0x169C, 0x169C, 43 },
    { 0x16A0, 0x16EA, 50 },
    { 0x16EB, 0x16ED, 10 },
    { 0x16EE, 0x16F0, 50 },
    { 0x1700, 0x170C, 55 },
    { 0x170E, 0x1711, 55 },
    { 0x1712, 0x1714, 55 },
    { 0x1720, 0x1731, 26 },
    { 0x1732, 0x1734, 26 },
    { 0x1735, 0x1736, 10 },
    { 0x1740, 0x1751,  7 },
    { 0x1752, 0x1753,  7 },
    { 0x1760, 0x176C, 56 },
    { 0x176E, 0x1770, 56 },
    { 0x1772, 0x1773, 56 },
    { 0x1780, 0x17B3, 33 },
    { 0x17B4, 0x17B5, 33 },
    { 0x17B6, 0x17B6, 33 },
    { 0x17B7, 0x17BD, 33 },
    { 0x17BE, 0x17C5, 33 },
    { 0x17C6, 0x17C6, 33 },
    { 0x17C7, 0x17C8, 33 },
    { 0x17C9, 0x17D3, 33 },
    { 0x17D4, 0x17D6, 33 },
    { 0x17D7, 0x17D7, 33 },
    { 0x17D8, 0x17DA, 33 },
    { 0x17DB, 0x17DB, 33 },
    { 0x17DC, 0x17DC, 33 },
    { 0x17DD, 0x17DD, 33 },
    { 0x17E0, 0x17E9, 33 },
    { 0x17F0, 0x17F9, 33 },
    { 0x1800, 0x1801, 39 },
    { 0x1802, 0x1803, 10 },
    { 0x1804, 0x1804, 39 },
    { 0x1805, 0x1805, 10 },
    { 0x1806, 0x1806, 39 },
    { 0x1807, 0x180A, 39 },
    { 0x180B, 0x180D, 39 },
    { 0x180E, 0x180E, 39 },
    { 0x1810, 0x1819, 39 },
    { 0x1820, 0x1842, 39 },
    { 0x1843, 0x1843, 39 },
    { 0x1844, 0x1877, 39 },
    { 0x1880, 0x18A8, 39 },
    { 0x18A9, 0x18A9, 39 },
    { 0x1900, 0x191C, 36 },
    { 0x1920, 0x1922, 36 },
    { 0x1923, 0x1926, 36 },
    { 0x1927, 0x1928, 36 },
    { 0x1929, 0x192B, 36 },
    { 0x1930, 0x1931, 36 },
    { 0x1932, 0x1932, 36 },
    { 0x1933, 0x1938, 36 },
    { 0x1939, 0x193B, 36 },
    { 0x1940, 0x1940, 36 },
    { 0x1944, 0x1945, 36 },
    { 0x1946, 0x194F, 36 },
    { 0x1950, 0x196D, 57 },
    { 0x1970, 0x1974, 57 },
    { 0x1980, 0x19A9, 41 },
    { 0x19B0, 0x19C0, 41 },
    { 0x19C1, 0x19C7, 41 },
    { 0x19C8, 0x19C9, 41 },
    { 0x19D0, 0x19D9, 41 },
    { 0x19DE, 0x19DF, 41 },
    { 0x19E0, 0x19FF, 33 },
    { 0x1A00, 0x1A16,  6 },
    { 0x1A17, 0x1A18,  6 },
    { 0x1A19, 0x1A1B,  6 },
    { 0x1A1E, 0x1A1F,  6 },
    { 0x1B00, 0x1B03,  2 },
    { 0x1B04, 0x1B04,  2 },
    { 0x1B05, 0x1B33,  2 },
    { 0x1B34, 0x1B34,  2 },
    { 0x1B35, 0x1B35,  2 },
    { 0x1B36, 0x1B3A,  2 },
    { 0x1B3B, 0x1B3B,  2 },
    { 0x1B3C, 0x1B3C,  2 },
    { 0x1B3D, 0x1B41,  2 },
    { 0x1B42, 0x1B42,  2 },
    { 0x1B43, 0x1B44,  2 },
    { 0x1B45, 0x1B4B,  2 },
    { 0x1B50, 0x1B59,  2 },
    { 0x1B5A, 0x1B60,  2 },
    { 0x1B61, 0x1B6A,  2 },
    { 0x1B6B, 0x1B73,  2 },
    { 0x1B74, 0x1B7C,  2 },
    { 0x1D00, 0x1D25, 35 },
    { 0x1D26, 0x1D2A, 21 },
    { 0x1D2B, 0x1D2B, 14 },
    { 0x1D2C, 0x1D5C, 35 },
    { 0x1D5D, 0x1D61, 21 },
    { 0x1D62, 0x1D65, 35 },
    { 0x1D66, 0x1D6A, 21 },
    { 0x1D6B, 0x1D77, 35 },
    { 0x1D78, 0x1D78, 14 },
    { 0x1D79, 0x1D9A, 35 },
    { 0x1D9B, 0x1DBE, 35 },
    { 0x1DBF, 0x1DBF, 21 },
    { 0x1DC0, 0x1DCA, 29 },
    { 0x1DFE, 0x1DFF, 29 },
    { 0x1E00, 0x1E9B, 35 },
    { 0x1EA0, 0x1EF9, 35 },
    { 0x1F00, 0x1F15, 21 },
    { 0x1F18, 0x1F1D, 21 },
    { 0x1F20, 0x1F45, 21 },
    { 0x1F48, 0x1F4D, 21 },
    { 0x1F50, 0x1F57, 21 },
    { 0x1F59, 0x1F59, 21 },
    { 0x1F5B, 0x1F5B, 21 },
    { 0x1F5D, 0x1F5D, 21 },
    { 0x1F5F, 0x1F7D, 21 },
    { 0x1F80, 0x1FB4, 21 },
    { 0x1FB6, 0x1FBC, 21 },
    { 0x1FBD, 0x1FBD, 21 },
    { 0x1FBE, 0x1FBE, 21 },
    { 0x1FBF, 0x1FC1, 21 },
    { 0x1FC2, 0x1FC4, 21 },
    { 0x1FC6, 0x1FCC, 21 },
    { 0x1FCD, 0x1FCF, 21 },
    { 0x1FD0, 0x1FD3, 21 },
    { 0x1FD6, 0x1FDB, 21 },
    { 0x1FDD, 0x1FDF, 21 },
    { 0x1FE0, 0x1FEC, 21 },
    { 0x1FED, 0x1FEF, 21 },
    { 0x1FF2, 0x1FF4, 21 },
    { 0x1FF6, 0x1FFC, 21 },
    { 0x1FFD, 0x1FFE, 21 },
    { 0x2000, 0x200A, 10 },
    { 0x200B, 0x200B, 10 },
    { 0x200C, 0x200D, 29 },
    { 0x200E, 0x200F, 10 },
    { 0x2010, 0x2015, 10 },
    { 0x2016, 0x2017, 10 },
    { 0x2018, 0x2018, 10 },
    { 0x2019, 0x2019, 10 },
    { 0x201A, 0x201A, 10 },
    { 0x201B, 0x201C, 10 },
    { 0x201D, 0x201D, 10 },
    { 0x201E, 0x201E, 10 },
    { 0x201F, 0x201F, 10 },
    { 0x2020, 0x2027, 10 },
    { 0x2028, 0x2028, 10 },
    { 0x2029, 0x2029, 10 },
    { 0x202A, 0x202E, 10 },
    { 0x202F, 0x202F, 10 },
    { 0x2030, 0x2038, 10 },
    { 0x2039, 0x2039, 10 },
    { 0x203A, 0x203A, 10 },
    { 0x203B, 0x203E, 10 },
    { 0x203F, 0x2040, 10 },
    { 0x2041, 0x2043, 10 },
    { 0x2044, 0x2044, 10 },
    { 0x2045, 0x2045, 10 },
    { 0x2046, 0x2046, 10 },
    { 0x2047, 0x2051, 10 },
    { 0x2052, 0x2052, 10 },
    { 0x2053, 0x2053, 10 },
    { 0x2054, 0x2054, 10 },
    { 0x2055, 0x205E, 10 },
    { 0x205F, 0x205F, 10 },
    { 0x2060, 0x2063, 10 },
    { 0x206A, 0x206F, 10 },
    { 0x2070, 0x2070, 10 },
    { 0x2071, 0x2071, 35 },
    { 0x2074, 0x2079, 10 },
    { 0x207A, 0x207C, 10 },
    { 0x207D, 0x207D, 10 },
    { 0x207E, 0x207E, 10 },
    { 0x207F, 0x207F, 35 },
    { 0x2080, 0x2089, 10 },
    { 0x208A, 0x208C, 10 },
    { 0x208D, 0x208D, 10 },
    { 0x208E, 0x208E, 10 },
    { 0x2090, 0x2094, 35 },
    { 0x20A0, 0x20B5, 10 },
    { 0x20D0, 0x20DC, 29 },
    { 0x20DD, 0x20E0, 29 },
    { 0x20E1, 0x20E1, 29 },
    { 0x20E2, 0x20E4, 29 },
    { 0x20E5, 0x20EF, 29 },
    { 0x2100, 0x2101, 10 },
    { 0x2102, 0x2102, 10 },
    { 0x2103, 0x2106, 10 },
    { 0x2107, 0x2107, 10 },
    { 0x2108, 0x2109, 10 },
    { 0x210A, 0x2113, 10 },
    { 0x2114, 0x2114, 10 },
    { 0x2115, 0x2115, 10 },
    { 0x2116, 0x2118, 10 },
    { 0x2119, 0x211D, 10 },
    { 0x211E, 0x2123, 10 },
    { 0x2124, 0x2124, 10 },
    { 0x2125, 0x2125, 10 },
    { 0x2126, 0x2126, 21 },
    { 0x2127, 0x2127, 10 },
    { 0x2128, 0x2128, 10 },
    { 0x2129, 0x2129, 10 },
    { 0x212A, 0x212B, 35 },
    { 0x212C, 0x212D, 10 },
    { 0x212E, 0x212E, 10 },
    { 0x212F, 0x2131, 10 },
    { 0x2132, 0x2132, 35 },
    { 0x2133, 0x2134, 10 },
    { 0x2135, 0x2138, 10 },
    { 0x2139, 0x2139, 10 },
    { 0x213A, 0x213B, 10 },
    { 0x213C, 0x213F, 10 },
    { 0x2140, 0x2144, 10 },
    { 0x2145, 0x2149, 10 },
    { 0x214A, 0x214A, 10 },
    { 0x214B, 0x214B, 10 },
    { 0x214C, 0x214D, 10 },
    { 0x214E, 0x214E, 35 },
    { 0x2153, 0x215F, 10 },
    { 0x2160, 0x2182, 10 },
    { 0x2183, 0x2183, 10 },
    { 0x2184, 0x2184, 35 },
    { 0x2190, 0x2194, 10 },
    { 0x2195, 0x2199, 10 },
    { 0x219A, 0x219B, 10 },
    { 0x219C, 0x219F, 10 },
    { 0x21A0, 0x21A0, 10 },
    { 0x21A1, 0x21A2, 10 },
    { 0x21A3, 0x21A3, 10 },
    { 0x21A4, 0x21A5, 10 },
    { 0x21A6, 0x21A6, 10 },
    { 0x21A7, 0x21AD, 10 },
    { 0x21AE, 0x21AE, 10 },
    { 0x21AF, 0x21CD, 10 },
    { 0x21CE, 0x21CF, 10 },
    { 0x21D0, 0x21D1, 10 },
    { 0x21D2, 0x21D2, 10 },
    { 0x21D3, 0x21D3, 10 },
    { 0x21D4, 0x21D4, 10 },
    { 0x21D5, 0x21F3, 10 },
    { 0x21F4, 0x22FF, 10 },
    { 0x2300, 0x2307, 10 },
    { 0x2308, 0x230B, 10 },
    { 0x230C, 0x231F, 10 },
    { 0x2320, 0x2321, 10 },
    { 0x2322, 0x2328, 10 },
    { 0x2329, 0x2329, 10 },
    { 0x232A, 0x232A, 10 },
    { 0x232B, 0x237B, 10 },
    { 0x237C, 0x237C, 10 },
    { 0x237D, 0x239A, 10 },
    { 0x239B, 0x23B3, 10 },
    { 0x23B4, 0x23DB, 10 },
    { 0x23DC, 0x23E1, 10 },
    { 0x23E2, 0x23E7, 10 },
    { 0x2400, 0x2426, 10 },
    { 0x2440, 0x244A, 10 },
    { 0x2460, 0x249B, 10 },
    { 0x249C, 0x24E9, 10 },
    { 0x24EA, 0x24FF, 10 },
    { 0x2500, 0x25B6, 10 },
    { 0x25B7, 0x25B7, 10 },
    { 0x25B8, 0x25C0, 10 },
    { 0x25C1, 0x25C1, 10 },
    { 0x25C2, 0x25F7, 10 },
    { 0x25F8, 0x25FF, 10 },
    { 0x2600, 0x266E, 10 },
    { 0x266F, 0x266F, 10 },
    { 0x2670, 0x269C, 10 },
    { 0x26A0, 0x26B2, 10 },
    { 0x2701, 0x2704, 10 },
    { 0x2706, 0x2709, 10 },
    { 0x270C, 0x2727, 10 },
    { 0x2729, 0x274B, 10 },
    { 0x274D, 0x274D, 10 },
    { 0x274F, 0x2752, 10 },
    { 0x2756, 0x2756, 10 },
    { 0x2758, 0x275E, 10 },
    { 0x2761, 0x2767, 10 },
    { 0x2768, 0x2768, 10 },
    { 0x2769, 0x2769, 10 },
    { 0x276A, 0x276A, 10 },
    { 0x276B, 0x276B, 10 },
    { 0x276C, 0x276C, 10 },
    { 0x276D, 0x276D, 10 },
    { 0x276E, 0x276E, 10 },
    { 0x276F, 0x276F, 10 },
    { 0x2770, 0x2770, 10 },
    { 0x2771, 0x2771, 10 },
    { 0x2772, 0x2772, 10 },
    { 0x2773, 0x2773, 10 },
    { 0x2774, 0x2774, 10 },
    { 0x2775, 0x2775, 10 },
    { 0x2776, 0x2793, 10 },
    { 0x2794, 0x2794, 10 },
    { 0x2798, 0x27AF, 10 },
    { 0x27B1, 0x27BE, 10 },
    { 0x27C0, 0x27C4, 10 },
    { 0x27C5, 0x27C5, 10 },
    { 0x27C6, 0x27C6, 10 },
    { 0x27C7, 0x27CA, 10 },
    { 0x27D0, 0x27E5, 10 },
    { 0x27E6, 0x27E6, 10 },
    { 0x27E7, 0x27E7, 10 },
    { 0x27E8, 0x27E8, 10 },
    { 0x27E9, 0x27E9, 10 },
    { 0x27EA, 0x27EA, 10 },
    { 0x27EB, 0x27EB, 10 },
    { 0x27F0, 0x27FF, 10 },
    { 0x2800, 0x28FF,  5 },
    { 0x2900, 0x2982, 10 },
    { 0x2983, 0x2983, 10 },
    { 0x2984, 0x2984, 10 },
    { 0x2985, 0x2985, 10 },
    { 0x2986, 0x2986, 10 },
    { 0x2987, 0x2987, 10 },
    { 0x2988, 0x2988, 10 },
    { 0x2989, 0x2989, 10 },
    { 0x298A, 0x298A, 10 },
    { 0x298B, 0x298B, 10 },
    { 0x298C, 0x298C, 10 },
    { 0x298D, 0x298D, 10 },
    { 0x298E, 0x298E, 10 },
    { 0x298F, 0x298F, 10 },
    { 0x2990, 0x2990, 10 },
    { 0x2991, 0x2991, 10 },
    { 0x2992, 0x2992, 10 },
    { 0x2993, 0x2993, 10 },
    { 0x2994, 0x2994, 10 },
    { 0x2995, 0x2995, 10 },
    { 0x2996, 0x2996, 10 },
    { 0x2997, 0x2997, 10 },
    { 0x2998, 0x2998, 10 },
    { 0x2999, 0x29D7, 10 },
    { 0x29D8, 0x29D8, 10 },
    { 0x29D9, 0x29D9, 10 },
    { 0x29DA, 0x29DA, 10 },
    { 0x29DB, 0x29DB, 10 },
    { 0x29DC, 0x29FB, 10 },
    { 0x29FC, 0x29FC, 10 },
    { 0x29FD, 0x29FD, 10 },
    { 0x29FE, 0x2AFF, 10 },
    { 0x2B00, 0x2B1A, 10 },
    { 0x2B20, 0x2B23, 10 },
    { 0x2C00, 0x2C2E, 19 },
    { 0x2C30, 0x2C5E, 19 },
    { 0x2C60, 0x2C6C, 35 },
    { 0x2C74, 0x2C77, 35 },
    { 0x2C80, 0x2CE4, 11 },
    { 0x2CE5, 0x2CEA, 11 },
    { 0x2CF9, 0x2CFC, 11 },
    { 0x2CFD, 0x2CFD, 11 },
    { 0x2CFE, 0x2CFF, 11 },
    { 0x2D00, 0x2D25, 18 },
    { 0x2D30, 0x2D65, 63 },
    { 0x2D6F, 0x2D6F, 63 },
    { 0x2D80, 0x2D96, 17 },
    { 0x2DA0, 0x2DA6, 17 },
    { 0x2DA8, 0x2DAE, 17 },
    { 0x2DB0, 0x2DB6, 17 },
    { 0x2DB8, 0x2DBE, 17 },
    { 0x2DC0, 0x2DC6, 17 },
    { 0x2DC8, 0x2DCE, 17 },
    { 0x2DD0, 0x2DD6, 17 },
    { 0x2DD8, 0x2DDE, 17 },
    { 0x2E00, 0x2E01, 10 },
    { 0x2E02, 0x2E02, 10 },
    { 0x2E03, 0x2E03, 10 },
    { 0x2E04, 0x2E04, 10 },
    { 0x2E05, 0x2E05, 10 },
    { 0x2E06, 0x2E08, 10 },
    { 0x2E09, 0x2E09, 10 },
    { 0x2E0A, 0x2E0A, 10 },
    { 0x2E0B, 0x2E0B, 10 },
    { 0x2E0C, 0x2E0C, 10 },
    { 0x2E0D, 0x2E0D, 10 },
    { 0x2E0E, 0x2E16, 10 },
    { 0x2E17, 0x2E17, 10 },
    { 0x2E1C, 0x2E1C, 10 },
    { 0x2E1D, 0x2E1D, 10 },
    { 0x2E80, 0x2E99, 24 },
    { 0x2E9B, 0x2EF3, 24 },
    { 0x2F00, 0x2FD5, 24 },
    { 0x2FF0, 0x2FFB, 10 },
    { 0x3000, 0x3000, 10 },
    { 0x3001, 0x3003, 10 },
    { 0x3004, 0x3004, 10 },
    { 0x3005, 0x3005, 24 },
    { 0x3006, 0x3006, 10 },
    { 0x3007, 0x3007, 24 },
    { 0x3008, 0x3008, 10 },
    { 0x3009, 0x3009, 10 },
    { 0x300A, 0x300A, 10 },
    { 0x300B, 0x300B, 10 },
    { 0x300C, 0x300C, 10 },
    { 0x300D, 0x300D, 10 },
    { 0x300E, 0x300E, 10 },
    { 0x300F, 0x300F, 10 },
    { 0x3010, 0x3010, 10 },
    { 0x3011, 0x3011, 10 },
    { 0x3012, 0x3013, 10 },
    { 0x3014, 0x3014, 10 },
    { 0x3015, 0x3015, 10 },
    { 0x3016, 0x3016, 10 },
    { 0x3017, 0x3017, 10 },
    { 0x3018, 0x3018, 10 },
    { 0x3019, 0x3019, 10 },
    { 0x301A, 0x301A, 10 },
    { 0x301B, 0x301B, 10 },
    { 0x301C, 0x301C, 10 },
    { 0x301D, 0x301D, 10 },
    { 0x301E, 0x301F, 10 },
    { 0x3020, 0x3020, 10 },
    { 0x3021, 0x3029, 24 },
    { 0x302A, 0x302F, 29 },
    { 0x3030, 0x3030, 10 },
    { 0x3031, 0x3035, 10 },
    { 0x3036, 0x3037, 10 },
    { 0x3038, 0x303A, 24 },
    { 0x303B, 0x303B, 24 },
    { 0x303C, 0x303C, 10 },
    { 0x303D, 0x303D, 10 },
    { 0x303E, 0x303F, 10 },
    { 0x3041, 0x3096, 28 },
    { 0x3099, 0x309A, 29 },
    { 0x309B, 0x309C, 10 },
    { 0x309D, 0x309E, 28 },
    { 0x309F, 0x309F, 28 },
    { 0x30A0, 0x30A0, 10 },
    { 0x30A1, 0x30FA, 31 },
    { 0x30FB, 0x30FB, 10 },
    { 0x30FC, 0x30FC, 10 },
    { 0x30FD, 0x30FE, 31 },
    { 0x30FF, 0x30FF, 31 },
    { 0x3105, 0x312C,  4 },
    { 0x3131, 0x318E, 25 },
    { 0x3190, 0x3191, 10 },
    { 0x3192, 0x3195, 10 },
    { 0x3196, 0x319F, 10 },
    { 0x31A0, 0x31B7,  4 },
    { 0x31C0, 0x31CF, 10 },
    { 0x31F0, 0x31FF, 31 },
    { 0x3200, 0x321E, 25 },
    { 0x3220, 0x3229, 10 },
    { 0x322A, 0x3243, 10 },
    { 0x3250, 0x3250, 10 },
    { 0x3251, 0x325F, 10 },
    { 0x3260, 0x327D, 25 },
    { 0x327E, 0x327F, 10 },
    { 0x3280, 0x3289, 10 },
    { 0x328A, 0x32B0, 10 },
    { 0x32B1, 0x32BF, 10 },
    { 0x32C0, 0x32FE, 10 },
    { 0x3300, 0x33FF, 10 },
    { 0x3400, 0x4DB5, 24 },
    { 0x4DC0, 0x4DFF, 10 },
    { 0x4E00, 0x9FBB, 24 },
    { 0xA000, 0xA014, 65 },
    { 0xA015, 0xA015, 65 },
    { 0xA016, 0xA48C, 65 },
    { 0xA490, 0xA4C6, 65 },
    { 0xA700, 0xA716, 10 },
    { 0xA717, 0xA71A, 10 },
    { 0xA720, 0xA721, 10 },
    { 0xA800, 0xA801, 53 },
    { 0xA802, 0xA802, 53 },
    { 0xA803, 0xA805, 53 },
    { 0xA806, 0xA806, 53 },
    { 0xA807, 0xA80A, 53 },
    { 0xA80B, 0xA80B, 53 },
    { 0xA80C, 0xA822, 53 },
    { 0xA823, 0xA824, 53 },
    { 0xA825, 0xA826, 53 },
    { 0xA827, 0xA827, 53 },
    { 0xA828, 0xA82B, 53 },
    { 0xA840, 0xA873, 48 },
    { 0xA874, 0xA877, 48 },
    { 0xAC00, 0xD7A3, 25 },
    { 0xF900, 0xFA2D, 24 },
    { 0xFA30, 0xFA6A, 24 },
    { 0xFA70, 0xFAD9, 24 },
    { 0xFB00, 0xFB06, 35 },
    { 0xFB13, 0xFB17,  1 },
    { 0xFB1D, 0xFB1D, 27 },
    { 0xFB1E, 0xFB1E, 27 },
    { 0xFB1F, 0xFB28, 27 },
    { 0xFB29, 0xFB29, 27 },
    { 0xFB2A, 0xFB36, 27 },
    { 0xFB38, 0xFB3C, 27 },
    { 0xFB3E, 0xFB3E, 27 },
    { 0xFB40, 0xFB41, 27 },
    { 0xFB43, 0xFB44, 27 },
    { 0xFB46, 0xFB4F, 27 },
    { 0xFB50, 0xFBB1,  0 },
    { 0xFBD3, 0xFD3D,  0 },
    { 0xFD3E, 0xFD3E, 10 },
    { 0xFD3F, 0xFD3F, 10 },
    { 0xFD50, 0xFD8F,  0 },
    { 0xFD92, 0xFDC7,  0 },
    { 0xFDF0, 0xFDFB,  0 },
    { 0xFDFC, 0xFDFC,  0 },
    { 0xFDFD, 0xFDFD, 10 },
    { 0xFE00, 0xFE0F, 29 },
    { 0xFE10, 0xFE16, 10 },
    { 0xFE17, 0xFE17, 10 },
    { 0xFE18, 0xFE18, 10 },
    { 0xFE19, 0xFE19, 10 },
    { 0xFE20, 0xFE23, 29 },
    { 0xFE30, 0xFE30, 10 },
    { 0xFE31, 0xFE32, 10 },
    { 0xFE33, 0xFE34, 10 },
    { 0xFE35, 0xFE35, 10 },
    { 0xFE36, 0xFE36, 10 },
    { 0xFE37, 0xFE37, 10 },
    { 0xFE38, 0xFE38, 10 },
    { 0xFE39, 0xFE39, 10 },
    { 0xFE3A, 0xFE3A, 10 },
    { 0xFE3B, 0xFE3B, 10 },
    { 0xFE3C, 0xFE3C, 10 },
    { 0xFE3D, 0xFE3D, 10 },
    { 0xFE3E, 0xFE3E, 10 },
    { 0xFE3F, 0xFE3F, 10 },
    { 0xFE40, 0xFE40, 10 },
    { 0xFE41, 0xFE41, 10 },
    { 0xFE42, 0xFE42, 10 },
    { 0xFE43, 0xFE43, 10 },
    { 0xFE44, 0xFE44, 10 },
    { 0xFE45, 0xFE46, 10 },
    { 0xFE47, 0xFE47, 10 },
    { 0xFE48, 0xFE48, 10 },
    { 0xFE49, 0xFE4C, 10 },
    { 0xFE4D, 0xFE4F, 10 },
    { 0xFE50, 0xFE52, 10 },
    { 0xFE54, 0xFE57, 10 },
    { 0xFE58, 0xFE58, 10 },
    { 0xFE59, 0xFE59, 10 },
    { 0xFE5A, 0xFE5A, 10 },
    { 0xFE5B, 0xFE5B, 10 },
    { 0xFE5C, 0xFE5C, 10 },
    { 0xFE5D, 0xFE5D, 10 },
    { 0xFE5E, 0xFE5E, 10 },
    { 0xFE5F, 0xFE61, 10 },
    { 0xFE62, 0xFE62, 10 },
    { 0xFE63, 0xFE63, 10 },
    { 0xFE64, 0xFE66, 10 },
    { 0xFE68, 0xFE68, 10 },
    { 0xFE69, 0xFE69, 10 },
    { 0xFE6A, 0xFE6B, 10 },
    { 0xFE70, 0xFE74,  0 },
    { 0xFE76, 0xFEFC,  0 },
    { 0xFEFF, 0xFEFF, 10 },
    { 0xFF01, 0xFF03, 10 },
    { 0xFF04, 0xFF04, 10 },
    { 0xFF05, 0xFF07, 10 },
    { 0xFF08, 0xFF08, 10 },
    { 0xFF09, 0xFF09, 10 },
    { 0xFF0A, 0xFF0A, 10 },
    { 0xFF0B, 0xFF0B, 10 },
    { 0xFF0C, 0xFF0C, 10 },
    { 0xFF0D, 0xFF0D, 10 },
    { 0xFF0E, 0xFF0F, 10 },
    { 0xFF10, 0xFF19, 10 },
    { 0xFF1A, 0xFF1B, 10 },
    { 0xFF1C, 0xFF1E, 10 },
    { 0xFF1F, 0xFF20, 10 },
    { 0xFF21, 0xFF3A, 35 },
    { 0xFF3B, 0xFF3B, 10 },
    { 0xFF3C, 0xFF3C, 10 },
    { 0xFF3D, 0xFF3D, 10 },
    { 0xFF3E, 0xFF3E, 10 },
    { 0xFF3F, 0xFF3F, 10 },
    { 0xFF40, 0xFF40, 10 },
    { 0xFF41, 0xFF5A, 35 },
    { 0xFF5B, 0xFF5B, 10 },
    { 0xFF5C, 0xFF5C, 10 },
    { 0xFF5D, 0xFF5D, 10 },
    { 0xFF5E, 0xFF5E, 10 },
    { 0xFF5F, 0xFF5F, 10 },
    { 0xFF60, 0xFF60, 10 },
    { 0xFF61, 0xFF61, 10 },
    { 0xFF62, 0xFF62, 10 },
    { 0xFF63, 0xFF63, 10 },
    { 0xFF64, 0xFF65, 10 },
    { 0xFF66, 0xFF6F, 31 },
    { 0xFF70, 0xFF70, 10 },
    { 0xFF71, 0xFF9D, 31 },
    { 0xFF9E, 0xFF9F, 10 },
    { 0xFFA0, 0xFFBE, 25 },
    { 0xFFC2, 0xFFC7, 25 },
    { 0xFFCA, 0xFFCF, 25 },
    { 0xFFD2, 0xFFD7, 25 },
    { 0xFFDA, 0xFFDC, 25 },
    { 0xFFE0, 0xFFE1, 10 },
    { 0xFFE2, 0xFFE2, 10 },
    { 0xFFE3, 0xFFE3, 10 },
    { 0xFFE4, 0xFFE4, 10 },
    { 0xFFE5, 0xFFE6, 10 },
    { 0xFFE8, 0xFFE8, 10 },
    { 0xFFE9, 0xFFEC, 10 },
    { 0xFFED, 0xFFEE, 10 },
    { 0xFFF9, 0xFFFB, 10 },
    { 0xFFFC, 0xFFFD, 10 },
    { 0x10000, 0x1000B, 37 },
    { 0x1000D, 0x10026, 37 },
    { 0x10028, 0x1003A, 37 },
    { 0x1003C, 0x1003D, 37 },
    { 0x1003F, 0x1004D, 37 },
    { 0x10050, 0x1005D, 37 },
    { 0x10080, 0x100FA, 37 },
    { 0x10100, 0x10101, 10 },
    { 0x10102, 0x10102, 10 },
    { 0x10107, 0x10133, 10 },
    { 0x10137, 0x1013F, 10 },
    { 0x10140, 0x10174, 21 },
    { 0x10175, 0x10178, 21 },
    { 0x10179, 0x10189, 21 },
    { 0x1018A, 0x1018A, 21 },
    { 0x10300, 0x1031E, 44 },
    { 0x10320, 0x10323, 44 },
    { 0x10330, 0x10340, 20 },
    { 0x10341, 0x10341, 20 },
    { 0x10342, 0x10349, 20 },
    { 0x1034A, 0x1034A, 20 },
    { 0x10380, 0x1039D, 64 },
    { 0x1039F, 0x1039F, 64 },
    { 0x103A0, 0x103C3, 45 },
    { 0x103C8, 0x103CF, 45 },
    { 0x103D0, 0x103D0, 45 },
    { 0x103D1, 0x103D5, 45 },
    { 0x10400, 0x1044F, 15 },
    { 0x10450, 0x1047F, 51 },
    { 0x10480, 0x1049D, 47 },
    { 0x104A0, 0x104A9, 47 },
    { 0x10800, 0x10805, 13 },
    { 0x10808, 0x10808, 13 },
    { 0x1080A, 0x10835, 13 },
    { 0x10837, 0x10838, 13 },
    { 0x1083C, 0x1083C, 13 },
    { 0x1083F, 0x1083F, 13 },
    { 0x10900, 0x10915, 49 },
    { 0x10916, 0x10919, 49 },
    { 0x1091F, 0x1091F, 49 },
    { 0x10A00, 0x10A00, 32 },
    { 0x10A01, 0x10A03, 32 },
    { 0x10A05, 0x10A06, 32 },
    { 0x10A0C, 0x10A0F, 32 },
    { 0x10A10, 0x10A13, 32 },
    { 0x10A15, 0x10A17, 32 },
    { 0x10A19, 0x10A33, 32 },
    { 0x10A38, 0x10A3A, 32 },
    { 0x10A3F, 0x10A3F, 32 },
    { 0x10A40, 0x10A47, 32 },
    { 0x10A50, 0x10A58, 32 },
    { 0x12000, 0x1236E, 12 },
    { 0x12400, 0x12462, 12 },
    { 0x12470, 0x12473, 12 },
    { 0x1D000, 0x1D0F5, 10 },
    { 0x1D100, 0x1D126, 10 },
    { 0x1D12A, 0x1D164, 10 },
    { 0x1D165, 0x1D166, 10 },
    { 0x1D167, 0x1D169, 29 },
    { 0x1D16A, 0x1D16C, 10 },
    { 0x1D16D, 0x1D172, 10 },
    { 0x1D173, 0x1D17A, 10 },
    { 0x1D17B, 0x1D182, 29 },
    { 0x1D183, 0x1D184, 10 },
    { 0x1D185, 0x1D18B, 29 },
    { 0x1D18C, 0x1D1A9, 10 },
    { 0x1D1AA, 0x1D1AD, 29 },
    { 0x1D1AE, 0x1D1DD, 10 },
    { 0x1D200, 0x1D241, 21 },
    { 0x1D242, 0x1D244, 21 },
    { 0x1D245, 0x1D245, 21 },
    { 0x1D300, 0x1D356, 10 },
    { 0x1D360, 0x1D371, 10 },
    { 0x1D400, 0x1D454, 10 },
    { 0x1D456, 0x1D49C, 10 },
    { 0x1D49E, 0x1D49F, 10 },
    { 0x1D4A2, 0x1D4A2, 10 },
    { 0x1D4A5, 0x1D4A6, 10 },
    { 0x1D4A9, 0x1D4AC, 10 },
    { 0x1D4AE, 0x1D4B9, 10 },
    { 0x1D4BB, 0x1D4BB, 10 },
    { 0x1D4BD, 0x1D4C3, 10 },
    { 0x1D4C5, 0x1D505, 10 },
    { 0x1D507, 0x1D50A, 10 },
    { 0x1D50D, 0x1D514, 10 },
    { 0x1D516, 0x1D51C, 10 },
    { 0x1D51E, 0x1D539, 10 },
    { 0x1D53B, 0x1D53E, 10 },
    { 0x1D540, 0x1D544, 10 },
    { 0x1D546, 0x1D546, 10 },
    { 0x1D54A, 0x1D550, 10 },
    { 0x1D552, 0x1D6A5, 10 },
    { 0x1D6A8, 0x1D6C0, 10 },
    { 0x1D6C1, 0x1D6C1, 10 },
    { 0x1D6C2, 0x1D6DA, 10 },
    { 0x1D6DB, 0x1D6DB, 10 },
    { 0x1D6DC, 0x1D6FA, 10 },
    { 0x1D6FB, 0x1D6FB, 10 },
    { 0x1D6FC, 0x1D714, 10 },
    { 0x1D715, 0x1D715, 10 },
    { 0x1D716, 0x1D734, 10 },
    { 0x1D735, 0x1D735, 10 },
    { 0x1D736, 0x1D74E, 10 },
    { 0x1D74F, 0x1D74F, 10 },
    { 0x1D750, 0x1D76E, 10 },
    { 0x1D76F, 0x1D76F, 10 },
    { 0x1D770, 0x1D788, 10 },
    { 0x1D789, 0x1D789, 10 },
    { 0x1D78A, 0x1D7A8, 10 },
    { 0x1D7A9, 0x1D7A9, 10 },
    { 0x1D7AA, 0x1D7C2, 10 },
    { 0x1D7C3, 0x1D7C3, 10 },
    { 0x1D7C4, 0x1D7CB, 10 },
    { 0x1D7CE, 0x1D7FF, 10 },
    { 0x20000, 0x2A6D6, 24 },
    { 0x2F800, 0x2FA1D, 24 },
    { 0xE0001, 0xE0001, 10 },
    { 0xE0020, 0xE007F, 10 },
    { 0xE0100, 0xE01EF, 29 },
    { 0x0, 0x0, -1 }
};

#endif

